/*
 * Created on 26-Nov-2003
 *
 */
package com.exponto.jstock;

import com.exponto.util.*;


/**
 * Stores the start and endpoints of a line in a scale independent way
 * so that the line can be redrawn when the scale is changed.
 * 
 * x axis is represented by date, y axis by a price value
 * 
 * @author kaare
 *
 */
public class PersistentPoint {
	Date x;
	double y;

	/**
	 * 
	 */
	public PersistentPoint(Date dx, double dy) {
		x = dx;
		y = dy;
	}
	public PersistentPoint(String dx, double dy) {
		x = new Date(dx);
		y = dy;
		
	}


	/**
	 * @return the Date representing the x1 coordinate 
	 */
	public Date getX() {
		return x;
	}


	/**
	 * @return a value (double) representing the y1 coordinate
	 */
	public double getY() {
		return y;
	}



	/**
	 * @param d Date representing the x dimension of the start point
	 */
	public void setX(Date d) {
		x = d;
	}


	/**
	 * @param d double representing the y dimension of the start point
	 */
	public void setY(double d) {
		y = d;
	}


}
