/*
 * Created on 15-Jun-2004
 *
 */
package com.exponto.jstock.io;

import java.net.URL;

import org.apache.log4j.PropertyConfigurator;

import junit.framework.TestCase;
import com.exponto.jstock.*;

/**
 * @author kaare
 * 
 * Test case for compering the two different filereaders.
 * 
 * The testcase assumes that UserPreferences is setup correctly for Netfonds 
 * formated file input (default settings).
 *
 */
public class FileReadTest extends TestCase {
	private int numberToGet = 1200;
	private String fileName = "nsg.OSE"; 
	private ReadGenericDataFile rGDF;
	private ReadNetfondsFile rNF;
	private LogDataSeries genericSeries;
	private LogDataSeries netfondsSeries;
	public static void main(String[] args) {
		junit.textui.TestRunner.run(FileReadTest.class);
	}

	/*
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		String resource ="/log.properties";
		//System.out.println("pwd: " + System.getProperty("user.dir"));
		//System.out.println("cp: " + System.getProperty("java.class.path"));
		URL configFileResource = jStock.class.getResource(resource);
		//System.out.println("cp: " + configFileResource.toString());
		PropertyConfigurator.configure(configFileResource);    	
		//logger.info(" Loading application");

		//jStock taa = new jStock();
		// Loading LogDataSeries for Netfonds file
		rNF = new ReadNetfondsFile();
		netfondsSeries =rNF.readSeries(fileName, numberToGet, 0);
		netfondsSeries.rotate();
		netfondsSeries.setCurrentPeriode();
	}

	/*
	 * @see TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	/**
	 * Constructor for FileReadTest.
	 * @param arg0
	 */
	public FileReadTest(String arg0) {
		super(arg0);
	}

	public void testReadGenericDataFile() {
		
		rGDF = new ReadGenericDataFile();
		try {
		genericSeries =rGDF.readSeries(fileName, numberToGet);
		} catch (Exception e) {
			System.out.println(" File not found " + fileName);
		}
		genericSeries.rotate();
		genericSeries.setCurrentPeriode();
		boolean ok = isEqual(netfondsSeries, genericSeries);
	}

	public void testReadSeries() {
		
	}

	public void testReadString() {
		
	}

	private boolean isEqual(LogDataSeries s1, LogDataSeries s2) {
		boolean result = true;
		LogTradingData lTD;
		LogTradingData lTD2;
		
		//= netfondsSeries.getNextLTD();
		while (s1.hasNextLTD()) {
			lTD = s1.getNextLTD();
			lTD2 = s2.getNextLTD();
			//System.out.println("Checking " + lTD.toString() + ", " + lTD2.toString());
			if (!lTD.equals(lTD2)) {
				result = false;
				System.out.println(" LTD's not equal, failed with: ");
				System.out.println("     " + lTD.toString());
				System.out.println("     " + lTD2.toString());
			}
		}
		System.out.println(" Result is: " + result);
		return result;
	}
}
