/*
 *                                 jStock
 *                    (C) Copyright 2004, Kaare Ranum
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials
 *      provided with the distribution.
 *
 *   3. Neither the name of Ex Ponto nor the names of its of its
 *      contributors may be used to endorse or promote products
 *      derived from this software without specific prior written
 *      permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


/*
 * Created on 18-Feb-2004
 *
 */
package com.exponto.jstock.popupwindows;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import com.exponto.jstock.UserPreferences;
import com.exponto.util.*;
//import com.exponto.jstock.io.Constants;
/**
 * Generates the content for the File input tab in the Options menu.
 * 
 * @author kaare
 *
 */
public class FileInputMenu {
	JComponent [][] compArray;
	private JLabel selectFileInputFormat;
	//private JCheckBox enableNetfondsBox;
	
	private ButtonGroup fileFormatGroup;
	private JRadioButton netfonds;
	private JRadioButton yahoo;
	private JRadioButton other;
//	private String fileFormatPropertyName = "Options.InputFileFormat";
	private final String netfondsProperty = "Netfonds";
	private final String yahooProperty = "Yahoo";
	private final String otherProperty ="Other";
	// Sets Yahoo as default selected, will be overwritten if found in properties file
	private String selectedFileFormat =yahooProperty; 
	
	private JLabel date;
	private JTextField dateInput;
	private JLabel dateFormat;
	private JTextField dateFormatInput;
//	private JLabel ticker;
//	private JTextField tickerInput;
//	private JLabel exch;
//	private JTextField exchInput;
	private JLabel open;
	private JTextField openInput;
	private JLabel high;
	private JTextField highInput;
	private JLabel low;
	private JTextField lowInput;
	private JLabel close;
	private JTextField closeInput;
	private JLabel volume;
	private JTextField volumeInput;

	private TableLayoutPanel tP;
	private JPanel fileInputPanel; 
	
	int rows = 7;
	int columns = 2;
	UserPreferences userPref;
//	static Dimension threeDigitDim = new Dimension(36, 14);	
	
	public FileInputMenu() {
		//System.out.println("Jlabel: " + rsi.toString());
		//System.out.println("JTextField: " + rsiText.toString());
		initComponents();
		initCompArray();	
	}

	public JPanel getPanel() {
		fileInputPanel = new JPanel();
		fileInputPanel.setLayout(new BorderLayout());
		JPanel checkBoxPanel = new JPanel();
		checkBoxPanel.setLayout(new FlowLayout());
		checkBoxPanel.add(selectFileInputFormat);
		//checkBoxPanel.add(enableNetfondsBox);
		checkBoxPanel.add(netfonds);
		checkBoxPanel.add(yahoo);
		checkBoxPanel.add(other);
		fileInputPanel.add(checkBoxPanel, BorderLayout.NORTH);
		tP = new TableLayoutPanel(compArray);
		netfonds.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				//System.out.println(" Selected file format was " + selectedFileFormat);
				if (selectedFileFormat.equals(otherProperty)) {
					fileInputPanel.remove(tP);
					fileInputPanel.revalidate();
					fileInputPanel.repaint();
				}
				selectedFileFormat = netfondsProperty;
				//System.out.println(" Selected file format changed to " + selectedFileFormat);
				userPref.setProperty(UserPreferences.fileFormatPropertyName, selectedFileFormat);
			}
		});
		yahoo.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				if (selectedFileFormat.equals(otherProperty)) {
					fileInputPanel.remove(tP);
					fileInputPanel.revalidate();
					fileInputPanel.repaint();
				}
				selectedFileFormat = yahooProperty;
				userPref.setProperty(UserPreferences.fileFormatPropertyName, selectedFileFormat);
			}
		});
		other.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				fileInputPanel.add(tP, BorderLayout.CENTER);
				fileInputPanel.revalidate();
				fileInputPanel.repaint();
				selectedFileFormat = otherProperty;
				userPref.setProperty(UserPreferences.fileFormatPropertyName, selectedFileFormat);
			}
		});
//		enableNetfondsBox.addActionListener(new ActionListener () {
//			public void actionPerformed(ActionEvent e) {
//				userPref.setEnablePos(!userPref.getEnablePos());
//				if (userPref.getEnablePos()) {
//					fileInputPanel.add(tP, BorderLayout.CENTER);	
//				} else {
//					fileInputPanel.remove(tP);
//				}
//				// Redraws the panel.
//				fileInputPanel.revalidate();
//				fileInputPanel.repaint();
//			}
//		});
		
		tP.setOpaque(true);
		fileInputPanel.setOpaque(true);
		if (selectedFileFormat.equals(otherProperty)) {
			fileInputPanel.add(tP, BorderLayout.CENTER);	
		}
		fileInputPanel.revalidate();
		return fileInputPanel;
	}
	public void save() {
//		userPref.setTickerPos(tickerInput.getText());
//		userPref.setExchangePos(exchInput.getText());
		userPref.setProperty(UserPreferences.fileFormatPropertyName, selectedFileFormat);
		userPref.setDatePos(dateInput.getText());
		userPref.setOpenPos(openInput.getText());
		userPref.setHighPos(highInput.getText());
		userPref.setLowPos(lowInput.getText());
		userPref.setClosePos(closeInput.getText());
		userPref.setVolumePos(volumeInput.getText());
		userPref.setDateFormat(dateFormatInput.getText());
		//logger.debug("Saved file input");
	}
	public void restore() {
		
//		tickerInput.setText(String.valueOf(userPref.getTickerPos()));
//		exchInput.setText(String.valueOf(userPref.getExchangePos()));
		setSelectedFileFormat(userPref);
		dateInput.setText(String.valueOf(userPref.getDatePos()));
		openInput.setText(String.valueOf(userPref.getOpenPos()));
		highInput.setText(String.valueOf(userPref.getHighPos()));
		lowInput.setText(String.valueOf(userPref.getLowPos()));
		closeInput.setText(String.valueOf(userPref.getClosePos()));
		volumeInput.setText(String.valueOf(userPref.getVolumePos()));
		dateFormatInput.setText(String.valueOf(userPref.getDateFormat()));

	}
	
	private void initComponents() {
		userPref = UserPreferences.getInstance();
		selectFileInputFormat = new JLabel("Select file format: ");
		//enableNetfondsBox = new JCheckBox("Check to enable", userPref.getEnablePos());
		
		String s = userPref.getProperty(UserPreferences.fileFormatPropertyName);
		if (s != null) {
			// Update if present in properties file
			selectedFileFormat = s;
		} else {
			// Save to properties file
			userPref.setProperty(UserPreferences.fileFormatPropertyName, selectedFileFormat);
		}
		netfonds = new JRadioButton(netfondsProperty);
		netfonds.setToolTipText("Use this for files from Netfonds or similar, see documentation for details");
		yahoo = new JRadioButton(yahooProperty);
		yahoo.setToolTipText("Use this for files from Yahoo or similar, see documentation for details");
		other = new JRadioButton(otherProperty);
		other.setToolTipText("Use this for other files. Please use table below, see documentation for details");
		this.setSelectedFileFormat(userPref);
		//netfonds.addActionListener();
		fileFormatGroup = new ButtonGroup();
		fileFormatGroup.add(netfonds);
		fileFormatGroup.add(yahoo);
		fileFormatGroup.add(other);

//		ticker = new JLabel("Column number for ticker");
//		tickerInput = new JTextField(String.valueOf(userPref.getTickerPos()), 3);
//		exch = new JLabel("Column number for exchange");
//		exchInput = new JTextField(String.valueOf(userPref.getExchangePos()), 3);
		date = new JLabel("Column number for date");
		dateInput = new JTextField(String.valueOf(userPref.getDatePos()), 3);
		dateFormat= new JLabel("Format of date");
		dateFormatInput = new JTextField(userPref.getDateFormat(), 10);
		open = new JLabel("Column number for open");
		openInput = new JTextField(String.valueOf(userPref.getOpenPos()), 3);
		high = new JLabel("Column number for high");
		highInput = new JTextField(String.valueOf(userPref.getHighPos()), 3);
		low = new JLabel("Column number for low");
		lowInput = new JTextField(String.valueOf(userPref.getLowPos()), 3);
		close = new JLabel("Column number for close");
		closeInput = new JTextField(String.valueOf(userPref.getClosePos()), 3);
		volume = new JLabel("Column number for volume");
		volumeInput = new JTextField(String.valueOf(userPref.getVolumePos()), 3);
//		String maTip = "Enter the number of days to use in moving average calculation. \nUse 0 for no moving average.";
		this.restore();
//		maText.setToolTipText(maTip);
	}
	
	private void initCompArray() {
		compArray = new JComponent[rows][];
		for (int i = 0; i < rows; i ++) {
			compArray[i] = new JComponent[columns]; 
		}
		compArray[0][0] = date;
		compArray[0][1] = dateInput;
//		compArray[1][0] = ticker;
//		compArray[1][1] = tickerInput;
//		compArray[2][0] = exch;
//		compArray[2][1] = exchInput;
		compArray[1][0] = open;
		compArray[1][1] = openInput;
		compArray[2][0] = high;
		compArray[2][1] = highInput;
		compArray[3][0] = low;
		compArray[3][1] = lowInput;
		compArray[4][0] = close;
		compArray[4][1] = closeInput;
		compArray[5][0] = volume;
		compArray[5][1] = volumeInput;
		compArray[6][0] = dateFormat;
		compArray[6][1] = dateFormatInput;
	}
	

	private void setSelectedFileFormat(UserPreferences uP) {
		selectedFileFormat = uP.getProperty(UserPreferences.fileFormatPropertyName);
		//System.out.println(" Selected file format is " + selectedFileFormat);
		if (selectedFileFormat.equals(netfondsProperty)) {
			netfonds.setSelected(true);
		} else 	if (selectedFileFormat.equals(yahooProperty)) {
			yahoo.setSelected(true);
		} else	if (selectedFileFormat.equals(otherProperty)) {
			other.setSelected(true);
		}
	}
}
